de.caff.generics.function

## Interface FragileProcedure2<E extends java.lang.Exception,P1,P2>

- Type Parameters:
    `P1` - first parameter type
    `P2` - second parameter type
  All Superinterfaces:
    FragileProcedure1<E,ITuple2<? extends P1,? extends P2>>
  Functional Interface:
    This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

      @FunctionalInterface
      public interface FragileProcedure2<E extends java.lang.Exception,P1,P2>
      extends FragileProcedure1<E,ITuple2<? extends P1,? extends P2>>

  Function without return and with two parameters. This provides the same functional interface as modern Java's `BiConsumer`, but in a more extensible way. As it is extending `BiConsumer` it can be used anywhere
  Author:
    Rammi
  See Also:
    `Procedure0`, `Procedure1`, `Procedure3`, `Procedure4`, `Procedure5`, `Procedure6`, `Procedure7`, `Procedure8`, `Procedure9`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static FragileProcedure2<?,?,?>` | `NULL` Procedure with two arguments which does nothing.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default <FR extends ITuple2<? extends P1,? extends P2>,FP> FragileProcedure1<E,FP>` | `after1(java.util.function.Function<FP,FR> before)` Get a chained procedure which first applies the given function, then this procedure.
    `default void` | `apply(ITuple2<? extends P1,? extends P2> tuple2)` Expand a tuple into the arguments of this procedure.
    `void` | `apply(P1 arg1, P2 arg2)` Run the function.
    `static <X extends java.lang.Exception,T1,T2> FragileProcedure2<X,T1,T2>` | `empty()` Return a procedure which does nothing.
    `default Procedure2<P1,P2>` | `nonFragile()` Convert this to a non-fragile procedure which does not throw a checked exception.
    `default Procedure2<P1,P2>` | `nonFragileX(Procedure3<? super E,? super P1,? super P2> exceptionHandler)` Convert this to a non-fragile procedure which does not a checked exception.
    `default FragileProcedure1<E,P2>` | `partial1(P1 argument)` Get a partially applied procedure.
    `default FragileProcedure1<E,P1>` | `partial2(P2 argument)` Get a partially applied procedure.
    `default FragileProcedure1<E,P2>` | `partialLeft(P1 argument)` Get a partially applied procedure.
    `default FragileProcedure1<E,P1>` | `partialRight(P2 argument)` Get a partially applied procedure.

    - ### Methods inherited from interface de.caff.generics.function.FragileProcedure1

      `applyNonNull, nonFragileX, partial`

- - ### Field Detail

    - #### NULL

          @NotNull
          static final FragileProcedure2<?,?,?> NULL

      Procedure with two arguments which does nothing. Use `empty()` instead.

  - ### Method Detail

    - #### apply

          default void apply(@NotNull
                             ITuple2<? extends P1,? extends P2> tuple2)
                      throws E extends java.lang.Exception

      Expand a tuple into the arguments of this procedure.
      Specified by:
        `apply` in interface `FragileProcedure1<E extends java.lang.Exception,ITuple2<? extends P1,? extends P2>>`
      Parameters:
        `tuple2` - tuple to expand
      Throws:
        `E` - on errors
        `E extends java.lang.Exception`

    - #### apply

          void apply(P1 arg1,
                     P2 arg2)
              throws E extends java.lang.Exception

      Run the function.
      Parameters:
        `arg1` - first function argument
        `arg2` - second function argument
      Throws:
        `E` - on errors
        `E extends java.lang.Exception`

    - #### nonFragile

          @NotNull
          default Procedure2<P1,P2> nonFragile()

      Convert this to a non-fragile procedure which does not throw a checked exception. This will instead throw an unchecked `WrappedFragileException` for any checked exception thrown during `apply(Object, Object)`.
      Specified by:
        `nonFragile` in interface `FragileProcedure1<E extends java.lang.Exception,ITuple2<? extends P1,? extends P2>>`
      Returns:
        non-fragile function
      See Also:
        `Procedure2.nonFragile(FragileProcedure2)`

    - #### nonFragileX

          @NotNull
          default Procedure2<P1,P2> nonFragileX(@NotNull
                                                         Procedure3<? super E,? super P1,? super P2> exceptionHandler)

      Convert this to a non-fragile procedure which does not a checked exception. This will instead throw an unchecked `WrappedFragileException` for any checked exception thrown during `apply(Object, Object)`.
      Parameters:
        `exceptionHandler` - handler called when an exception is encountered. It may either ignore it, throw an unchecked exception, or collect the exceptions
      Returns:
        non-fragile function
      See Also:
        `Procedure2.nonFragileX(FragileProcedure2, Procedure3)`

    - #### partialLeft

          @NotNull
          default FragileProcedure1<E,P2> partialLeft(P1 argument)

      Get a partially applied procedure.
      Parameters:
        `argument` - value applied for first argument
      Returns:
        partially evaluated procedure

    - #### partial1

          @NotNull
          default FragileProcedure1<E,P2> partial1(P1 argument)

      Get a partially applied procedure. This is the same as `partialLeft(Object)`, but with a name which is more consistent with functions having more arguments.
      Parameters:
        `argument` - value applied for first argument
      Returns:
        partially evaluated procedure

    - #### partialRight

          @NotNull
          default FragileProcedure1<E,P1> partialRight(P2 argument)

      Get a partially applied procedure.
      Parameters:
        `argument` - value applied for second argument
      Returns:
        partially evaluated procedure

    - #### partial2

          @NotNull
          default FragileProcedure1<E,P1> partial2(P2 argument)

      Get a partially applied procedure. This is the same as `partialRight(Object)`, but with a name which is more consistent with functions having more arguments.
      Parameters:
        `argument` - value applied for second argument
      Returns:
        partially evaluated procedure

    - #### after1

          @NotNull
          default <FR extends ITuple2<? extends P1,? extends P2>,FP> FragileProcedure1<E,FP> after1(@NotNull
                                                                                                             java.util.function.Function<FP,FR> before)

      Get a chained procedure which first applies the given function, then this procedure. The given function has to return a `ITuple2` with matching parametric types which are applied in their order to this procedure.
      Type Parameters:
        `FR` - function `before`'s return type, has to be a 2-tuple with matching types
        `FP` - function `before`'s parameter type, same for returned procedure
      Parameters:
        `before` - function to apply first, has to return a non-`null` result so unpacking the parameters from the tuple is possible
      Returns:
        chain of function and this procedure

    - #### empty

          @NotNull
          static <X extends java.lang.Exception,T1,T2> FragileProcedure2<X,T1,T2> empty()

      Return a procedure which does nothing. This just returns `NULL`, but the compiler will accept it smoothly.
      Specified by:
        `empty` in interface `FragileProcedure1<E extends java.lang.Exception,ITuple2<? extends P1,? extends P2>>`
      Type Parameters:
        `X` - exception type
        `T1` - first argument type
        `T2` - second argument type
      Returns:
        do-nothing procedure